unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppComm, ppRelatv, ppProd, ppClass, ppReport, StdCtrls, ppStrtch,
  ppSubRpt, ppCtrls, ppVar, ppPrnabl, ppBands, ppCache, daDataView,
  daQueryDataView, daDBBDE, ppModule, daDataModule, daSQL,
  daSQLBuilder;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppTitleBand1: TppTitleBand;
    ppLabel1: TppLabel;
    ppSystemVariable1: TppSystemVariable;
    ppSystemVariable2: TppSystemVariable;
    ppDBText1: TppDBText;
    ppLabel2: TppLabel;
    ppDBText2: TppDBText;
    ppLabel3: TppLabel;
    ppLine1: TppLine;
    ppLine2: TppLine;
    daBDEQueryDataView2: TdaBDEQueryDataView;
    ppSubReport1: TppSubReport;
    ppChildReport1: TppChildReport;
    ppDetailBand2: TppDetailBand;
    ppDBText3: TppDBText;
    ppDBText4: TppDBText;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ehDataView_AfterGenerateSQL(Sender: TObject; aSQL: TdaSQL);
    procedure ehDataView_BeforeGenerateSQL(Sender: TObject; aSQL: TdaSQL);
    function GetDataViewForReport(aReport: TppCustomReport): TdaQueryDataView;
    procedure PrepareReport(aReport: TppCustomReport);
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  PrepareReport(ppReport1);
  ppReport1.Print;
end;

function TForm1.GetDataViewForReport(aReport: TppCustomReport): TdaQueryDataView;
begin

  if aReport.DataPipeline = nil then
    Result := nil
  else if not(aReport.DataPipeline.DataView is TdaQueryDataView) then
    Result := nil
  else
    Result := TdaQueryDataView(aReport.DataPipeline.DataView);

end;

procedure TForm1.PrepareReport(aReport: TppCustomReport);
var
  lDataView: TdaQueryDataView;
begin

  lDataView := GetDataViewForReport(aReport);

  // add event-handlers for the before/after generate SQL events
  if (lDataView <> nil) then
    begin
      lDataView.OnBeforeGenerateSQL := ehDataView_BeforeGenerateSQL;
      lDataView.OnAfterGenerateSQL  := ehDataView_AfterGenerateSQL;
    end;

end;

procedure TForm1.ehDataView_BeforeGenerateSQL(Sender: TObject; aSQL: TdaSQL);
var
  lSQLBuilder: TdaSQLBuilder;
begin

  // use SQLBuilder to add search criteria
  lSQLBuilder := TdaSQLBuilder.Create(aSQL);

  lSQLBuilder.SearchCriteria.Add('Customer', 'Company', 'Like', 'A');

  lSQLBuilder.Free;

end;

procedure TForm1.ehDataView_AfterGenerateSQL(Sender: TObject; aSQL: TdaSQL);
var
  lSQLBuilder: TdaSQLBuilder;
begin

  // use SQLBuilder to remove search criteria
  lSQLBuilder := TdaSQLBuilder.Create(aSQL);

  lSQLBuilder.SearchCriteria.Remove('Customer', 'Company');

  lSQLBuilder.Free;

end;



end.
